#include <vector>
#include <string>
#include "testlib.h"
#include <iostream>
#include <map>

using namespace std;

void modify(vector <vector <int>> &f, int u, int l, int d, int r, int br) {
	for (int i = u; i <= d; ++i)
		for (int j = l; j <= r; ++j)
			f[i][j] += br;
}

long long diff(vector <vector <int>> &f, vector <vector <int>> &f2) {
	long long ans = 0;
	for (int i = 0; i < f.size(); ++i)
		for (int j = 0; j < f[0].size(); ++j)
			ans += abs(f[i][j] - f2[i][j]);
	return ans;
}
	

int main(int argc, char **argv)
{
  registerTestlibCmd(argc, argv);

  double score = 0;
	int tests = inf.readInt();
	for (int test = 0; test < tests; ++test) {
		int n = inf.readInt();
		int m = inf.readInt();
		vector <vector <int> > img(n);
		for (int i = 0; i < n; ++i)
			img[i].resize(m, 0);
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
				img[i][j] = inf.readInt();
		vector <vector <int> > ai(n);
		for (int i = 0; i < n; ++i)
			ai[i].resize(m, 0);
		int aq = ans.readInt();
		for (int i = 0; i < aq; ++i) {
			int u = ans.readInt() - 1;
			int l = ans.readInt() - 1;
			int d = ans.readInt() - 1;
			int r = ans.readInt() - 1;
			int br = ans.readInt();
			modify(ai, u, l, d, r, br);
//			cerr << test << ' ' << i << ' ' << u << ' ' << l << ' ' << d << ' ' << r << ' ' << br << '\n';
		}
		long long adiff = diff(ai, img);
		vector <vector <int> > oi(n);
		for (int i = 0; i < n; ++i)
			oi[i].resize(m, 0);

		int oq = ouf.readInt();
		if (oq > 16)
			quitf(_wa, "Too many rectangles in testcase %d", test + 1);
		for (int i = 0; i < oq; ++i) {
			int u = ouf.readInt() - 1;
			int l = ouf.readInt() - 1;
			int d = ouf.readInt() - 1;
			int r = ouf.readInt() - 1;
			int br = ouf.readInt();
			if (u < 0 || u >= n || d < 0 || d >= n || u > d || l < 0 || l >= m || r < 0 || r >= m || l > r)
				quitf(_wa, "Bad rectangle number %d in testcase %d", i + 1, test + 1);
			modify(oi, u, l, d, r, br);
		}
		long long odiff = diff(oi, img);
		double nscore = 10 * ((long double) adiff + 100) / ((long double) odiff + 100);
		score += nscore;
//		if (odiff < adiff)
//			quitf(_fail, "Testcase %d, participant found %lld, jury has %lld", test + 1, odiff, adiff);
	}
	
  quitf(_ok, "participant's solution is ok");

  return 0;
} 